extends RigidBody2D

var isPiloting = false
var keys = {}
var motion = Vector2(0,0)
const SPEED = 5

const DIRECTION = {
	"LEFT":Vector2 (-1,0),
	"RIGHT":Vector2 (1,0),
	"UP":Vector2 (0,-1),
	"DOWN":Vector2 (0,1)
}

onready var rid = get_rid()


#https://github.com/godotengine/godot/blob/53a2b0a5cec83628474b5f95312fd008e7c213ef/scene/2d/physics_body_2d.cpp
func moveAndCollide(body, motion, infinite_inertia, margin,state,motionResult = null):
	
	
	# workaround, but just works for our player in ship,
	# issue still stands for other rigidbodys like asteroids in gitHubIssue .gif
	
#	var colliding = Physics2DServer.body_test_motion(rid,state.transform,motion,infinite_inertia, margin,motionResult)

	var colliding = body.test_motion(motion, infinite_inertia, margin, motionResult)
	
	if not colliding:
		var t = Transform2D(body.transform)
		t.origin += motion
		body.transform = t
#		print("state.transform.origin: ",state.transform.origin,"<- shouldn't Y be the same too?->","body.global_transform.origin: ",body.global_transform.origin)
	return colliding
	
func moveAndSlide(body, movement, state):
	#bool test_motion( Vector2 motion, bool infinite_inertia=true, float margin=0.08, Physics2DTestMotionResult result=null )
	var motionResult = Physics2DTestMotionResult.new()
	var motion = movement
	var colliding = moveAndCollide(body, motion, true, 0.01,state , motionResult)
	if colliding:
		var colliderNormale = motionResult.get_collision_normal()
		if not colliderNormale.normalized().round() == motion.normalized().round(): # if not same direction
			if colliderNormale.dot(motion)<0:
				motion = motionResult.motion_remainder
				motion = motion.slide(colliderNormale)
				moveAndCollide(body,motion, true, 0.01,state)
		else:
			moveAndCollide(body,motion, true, motion.length()*2,state)

func _ready():
	clearKeys()
	pass
	
func clearKeys():
	keys = {"up": false, "down": false, "left": false, "right": false}
	
func _integrate_forces(state):
	motion = Vector2(0,0)
	if keys.up:
		motion += DIRECTION.UP
	if keys.down:
		motion += DIRECTION.DOWN
	if keys.left:
		motion += DIRECTION.LEFT
	if keys.right:
		motion += DIRECTION.RIGHT
		
	motion = motion.normalized() * SPEED
	if MODE_KINEMATIC:
		moveAndSlide(self,motion,state)
	
func _input(event):
	if event is InputEventKey:
		if event.is_action_pressed("ui_up"):
			keys.up = true
		elif event.is_action_released("ui_up"):
			keys.up = false
		if event.is_action_pressed("ui_left"):
			keys.left = true
		elif event.is_action_released("ui_left"):
			keys.left = false
		if event.is_action_pressed("ui_right"):
			keys.right = true
		elif event.is_action_released("ui_right"):
			keys.right = false
		if event.is_action_pressed("ui_down"):
			keys.down = true
		elif event.is_action_released("ui_down"):
			keys.down = false